#include <math.h>
#include "invsubs.h"
#define kVerySmall 0.000001

void GetModelRough(int m,float *s,int nx,int ny,float *meanvel, float *roughvel);
void  GetARough(float *pS, int nx, int ny, float *meanvel, float *roughvel);

void GetModelRough(int m,float *s,int nx,int ny,float *meanvel, float *roughvel)
{

  float  *pS;
  float mean, var;
  
      pS = &s[m*nx*ny];
      GetARough(pS, nx, ny, &mean, &var);
      *meanvel = mean;
      *roughvel = var;

}

void  GetARough(float *s, int nx, int ny, float *meanvel, float *roughvel)
{
	double sum0, sumx, sumxx;
	double mean, var;
	int i ;
	double vel;
	sum0 = 0.0;
	sumx = 0.0;
	sumxx = 0.0;
	for (i = 0; i < nx * ny; i++) {
		if(fabs(s[i]) > kVerySmall){
			vel = 1 / s[i];
			sum0 += 1.0 ;
			sumx += vel ;
			sumxx += vel*vel;
		}
	}
	mean = sumx/sum0;
	var = (sumxx - sum0*mean*mean)/sum0;
	*meanvel = mean;
	*roughvel = var;
	
}
