c------
c      conversion between geodetic and geocentric
c-----
      implicit none
      logical togeocentric
      real xlat, xlon
      real geoglat,geoglon
      real geoclat,geoclon
        call gcmdln(togeocentric)
      read(5,*,end=9000,err=9000)xlat,xlon
      if(togeocentric)then
         geoglat = xlat
         geoglon = xlon
         call geog_to_geoc(geoglat,geoglon,geoclat,geoclon)
         WRITE(6,*)geoclat,geoclon
      else
         geoclat = xlat
         geoclon = xlon
         call geoc_to_geog(geoclat,geoclon,geoglat,geoglon)
         WRITE(6,*)geoglat,geoglon
      endif
 9000 continue
      end
      subroutine  gcmdln(togeocentric)
c-----
c     to geocentric  L  .true. convert geodetic to geocentric
c                      .false. convert geocentric to geodetic
c-----
      implicit none
      logical togeocentric

      character names*80
      integer mnmarg
      integer i, nmarg

      togeocentric = .true.

      i = 0
      nmarg = mnmarg()
 1000 continue
          i = i + 1
          if(i.gt.nmarg)go to 2000
          call mgtarg(i,names)
          if(names(1:7).eq.'-TOGEOC')then
                togeocentric = .true.
          else if(names(1:7).eq.'-TOGEOD')then
                togeocentric = .false.
          else if(names(1:2).eq.'-h' .or. names(1:2).eq.'-?')then
              call usage(' ')
          endif
      go to 1000
 2000 continue
      end

      subroutine usage()
      integer LER
      parameter (LER=0)
      write(LER,*)'Usage: geoconv [-TOGEOCENTRIC|-TOGEODETIC]',
     1  ' [-h] [-?]'
      write(LER,*)
     1  'e.g. echo 39 -90 | geoconv -TOGEOCENTRIC '
      write(LER,*)
     1  'gives    38.811913   -90.000000     on the standard output'
      write(LER,*)
     1    ' -TOGEOCENTRIC (default true) convert to geocentric'
      write(LER,*)
     1    ' -TOGEODETIC  (default false) convert to geodetic'
      write(LER,*)
     1    ' -h                            this command help'
      write(LER,*)
     1    ' -?                            this command help'
      stop
      end

        function mnmarg()
c---------------------------------------------------------------------c
c                                                                     c
c      COMPUTER PROGRAMS IN SEISMOLOGY                                c
c      VOLUME V                                                       c
c                                                                     c
c      SUBROUTINE: MNMARG                                             c
c                                                                     c
c      COPYRIGHT 1996 R. B. Herrmann                                  c
c                                                                     c
c      Department of Earth and Atmospheric Sciences                   c
c      Saint Louis University                                         c
c      221 North Grand Boulevard                                      c
c      St. Louis, Missouri 63103                                      c
c      U. S. A.                                                       c
c                                                                     c
c---------------------------------------------------------------------c
        implicit none
        integer iargc
        integer mnmarg
            mnmarg = iargc()
        return
        end

        subroutine mgtarg(i,name)
c---------------------------------------------------------------------c
c                                                                     c
c      COMPUTER PROGRAMS IN SEISMOLOGY                                c
c      VOLUME V                                                       c
c                                                                     c
c      SUBROUTINE: MGTARG                                             c
c                                                                     c
c      COPYRIGHT 1996 R. B. Herrmann                                  c
c                                                                     c
c      Department of Earth and Atmospheric Sciences                   c
c      Saint Louis University                                         c
c      221 North Grand Boulevard                                      c
c      St. Louis, Missouri 63103                                      c
c      U. S. A.                                                       c
c                                                                     c
c---------------------------------------------------------------------c
c-----
c       return the i'th command line argument
c
c       This version works on SUN, IBM RS6000
c-----
        implicit none
        integer i
        character name*(*)
            call getarg(i,name)
        return
        end

c-----
c     online tool at http://www.apsalin.com/convert-geodetic-to-cartesian.aspx
c     and then look to xyz to get desired geocentric angle
c-----
c     Geodetic Coordinate Conversions
c     James R. Clynch
c     Naval Postgraduate School, 2002
c     www.oc.nps.edu/oc2902w/coord/coordcvt.pdf
c-----
c     https://en.wikipedia.org/wiki/Latitude
c     f = flattening = (a-b)/b where b = polar radius and a = equatorial radius
c     e^2 = 2f - f^2
c     b = a(1-f) = a(sqrt(1-e^2)
c     WGS84 ellipsoid
c     a (equatorial radius): 6378137.0 m exactly
c     1/f =  (inverse flattening): 298.257223563 exactly
c       from which
c     b (polar radius): 6356752.3142 m
c     e^2 (eccentricity squared): 0.00669437999014
c     tan lat_geocentric = (1 - e^2) tan lat_geodetic
c-----
c
c     From PROGRAMS.330/VOLI/src/udelaz.c
C   double degrad = 0.0174532925199433;     /* degrees to radians */
C   double a = 6378.137 ;                   /* equatorial radius */
C   double b = 6356.752 ;                   /* polar radius = a(1-f) */
C   double f = 0.003352810664747481 ;       /* f = 1 - b/a = 
C                                                    1/298.257223563 */
C   double e = 0.081819191 ;                        /* eccentricity (A.38)
C                                                   e^2 = (a^2 - b^2)/a^2
C                                                   e^2 = 2f - f^2 */
C   double e2 = 0.006694379990141317 ;      /* e^2 */
C   double eps = 0.006739496742276435 ;     /* second ellipticity (A.42)
C                                                   eps = (a^2 - b^2)/b^2
C                                                   = e^2/(1-e^2) */
C   static float RE=6371.003;
C           c = cos(degrad*lat);
C           s = sin(degrad*lat);
C           e4 = (1.-e2)*(1.-e2);
C           fac = sqrt(e4 + (1.0-e4)*c*c);
C           *slat = (1.-e2) * s /fac;
C           *clat =      c /fac;
C   
c-----
      subroutine geog_to_geoc(geoglat,geoglon,geoclat,geoclon)
      real geoglat,geoglon,geoclat,geoclon
      double precision degrad, a, b, f, e, e2, eps, RE, e4, fac
      double precision c, s, clat, slat, dang
c-----
c     define constants
c-----
      e2 = 0.006694379990141317
      degrad = 0.0174532925199433

c-----
c     longitude does not change
c-----
      geoclon = geoglon
c-----
c     the conversion formula is typically given in terms of tan
c     by forming cos and sin and normalizing so that cos^2 + sin^2 = 1
c     we can use the atan2 to get proper angle in radians
c-----
      c = dcos(degrad*geoglat)
      s = dsin(degrad*geoglat)
      e4 = (1.-e2)*(1.-e2)
      fac = sqrt(e4 + (1.0-e4)*c*c)
      slat = (1.-e2) * s /fac
      clat =           c /fac
      geoclat = datan2(slat,clat)/degrad
      return
      end
      

      subroutine geoc_to_geog(geoclat,geoclon,geoglat,geoglon)
      real geoglat,geoglon,geoclat,geoclon
      double precision degrad, a, b, f, e, e2, eps, RE, e4, fac
      double precision c, s, clat, slat, dang
c-----
c     define constants
c-----
      e2 = 0.006694379990141317
      degrad = 0.0174532925199433

c-----
c     longitude does not change
c-----
      geoglon = geoclon
c-----
c     the conversion formula is typically given in terms of tan
c     by forming cos and sin and normalizing so that cos^2 + sin^2 = 1
c     we can use the atan2 to get proper angle in radians
c-----
      c = dcos(degrad*geoclat)
      s = dsin(degrad*geoclat)
      e4 = (1.-e2)*(1.-e2)
      fac = sqrt( (s/(1-e2))**2 + c**2)
      slat =           s /(fac*(1-e2))
      clat =           c /(fac)
      geoglat = datan2(slat,clat)/degrad
      return
      end
      

